;-----------------------------------------------------------------------
; DateiName        :  terminal.asm
;-----------------------------------------------------------------------
; Autor            :  Christian Rsch
;
; Erstellungsdatum :  18.12.2001
;-----------------------------------------------------------------------
; Info :  Ein Terminalprogramm fr Arme, die Tastendrcke werden
;         ber die Schnittstelle geschickt und nur die empfangenen
;         Tasten dargestellt
;-----------------------------------------------------------------------


; Dies ist das Daten-Segment

data SEGMENT
assume DS:data
data ends



; Dies ist das Stack-Segment

stackdata SEGMENT stack
assume SS:stackdata
        db 256 dup(?)           ; definiert die Grsse des Stacks
stackdata ends



; Dies ist das Code-Segment

code SEGMENT
ASSUME CS:code

start:                          ; hier beginnt die Abarbeitung des Programmshier beginnt die
        mov     ax, data        ; Adresse des Daten Segments nach ax
        mov     ds, ax          ; DatenSegment nach ds

        mov     ah,00h          ; serielle Schittstelle initialisieren
        mov     al,11110011b    ; alles an ;)
        mov     dx,1            ; COM2
        int     14h

        mov     ah,02h          ; Cursor setzen
        xor     bx,bx           ; Seite 0
        xor     dx,dx           ; obere Ecke
        int     10h

        mov     ax,0a20h        ; LeerZeichen ausgeben
        mov     cx,2048         ; dann ist der Bildschirm leer
        int     10h
        mov     cx,1            ; nur noch einzelne Zeichen ab jetzt
        push    dx

wait4keys:
        mov     ah,01h          ; Tastaturbuffer checken
        int     16h
        jz      nokeys          ; keine Taste gedrckt

        xor     ah,ah           ; Tastaturbuffer lesen
        int     16h

        cmp     al,27
        jz      ende            ; bei ESC beenden

        mov     ah,01h          ; Zeichen senden
        mov     dx,1            ; COM2
        int     14h
nokeys:
        mov     ah,03h          ; Status holen
        mov     dx,1            ; COM2
        int     14h
        test    ah,1b           ; Bit 0 gesetzt
        jz      wait4keys
        mov     ah,02h          ; Zeichen holen
        int     14h

        cmp     al,13
        jnz     noenter         ; kein ENTER => berspringen
        pop     dx
        mov     dl,79           ; Cursor ganz hinter
        push    dx
        jmp     move_cur        ; und bewegen ;)
noenter:
        cmp     al,8
        jnz     nodelete        ; kein DELETE => berspringen

        pop     dx
        mov     ah,02h          ; Cursor setzen
        dec     dl              ; eins weiter
        jge     del_ok          ; grsser 0, dann ok
        mov     dl,79           ; Spalte 79
        dec     dh              ; Zeile erhhen
        jge     del_ok          ; grsser 0, dann ok
        mov     dh,24           ; sonst ganz runter
del_ok:
        int     10h
        push    dx
        mov     ax,0a20h        ; LeerZeichen ausgeben
        int     10h
        jmp     wait4keys       ; nchsten Tastendruck abwarten
nodelete:

        cmp     al,' '          ; kleiner ' '(darunter sind Steuerzeichen)
        jb      wait4keys       ; dann zurck

        mov     ah,0ah          ; Zeichen ausgeben
        int     10h

move_cur:
        pop     dx
        mov     ah,02h          ; Cursor setzen
        inc     dl              ; eins weiter
        cmp     dl,80           ; kleiner 80
        jb      pos_ok          ; dann ok
        xor     dl,dl           ; Spalte 0
        inc     dh              ; Zeile erhhen
        cmp     dh,25           ; kleiner 25
        jb      pos_ok          ; dann ok
        xor     dh,dh           ; sonst wieder hoch
pos_ok:
        int     10h
        push    dx
        jmp     wait4keys
ende:
        pop    dx
        mov     ax, 4c00h       ; Funktion 4c00h (Programmende)
        int     21h             ; Interuppt auslsen


code ENDS



     end     start              ; Start als Einsprungpunkt definieren

;-----
; EOF
;-----
